import React, { useState, useEffect } from 'react';
import { Tree, Button } from "antd";
import { useRequest } from 'ahooks';
import { doFetch } from '@/utils/doFetch';

function Authtree({ roleId, reload }) {
    const [checkedKeys, setCheckedKeys] = useState([]),
        [checkedParentKeys, setCheckedParentKeys] = useState([]);
    const treedata = useRequest(async () => {
        let res = await doFetch({ url: '/ta_wms_auth/sysRolePermission/queryAll', params: { roleId } });
        setCheckedParentKeys(res?.data?.pcHalfCheckedKeys ?? []);
        setCheckedKeys(res?.data?.pcCheckedKeys ?? []);
        return res?.data ?? {};
    }),
        { run, loading } = useRequest(doFetch, {
            manual: true,
            onSuccess: (res, params) => {
                if (res?.code == '0000') {
                    reload && reload();
                }
            },
        })
    const onCheck = (checkedKeys, info) => {
        setCheckedKeys(checkedKeys);
        setCheckedParentKeys(info.halfCheckedKeys);
    };
    return <div>
        <Tree
            checkable
            onCheck={onCheck}
            checkedKeys={checkedKeys}
            treeData={treedata?.data?.pcTree ?? []}
        />
        <Button
            loading={loading}
            type="primary"
            style={{ width: "100%", marginTop: 15 }}
            onClick={() => {
                run({
                    url: '/ta_wms_auth/sysRolePermission/save',
                    params: {
                        roleId,
                        permissionIds:[
                            ...checkedKeys,
                            ...checkedParentKeys
                        ]
                    }
                })
            }}
        >
            提交
        </Button>
    </div>
}

export default Authtree;
